package com.franckbarbier._Programmable_thermostat_MODEL._Relays;

abstract public class Relay {

    /**
     * UML state machine diagram
     */
    protected com.pauware.pauware_engine.Core.AbstractState _Is_off;
    protected com.pauware.pauware_engine.Core.AbstractState _Is_on;
    protected com.pauware.pauware_engine.Core.AbstractStateMachine _Relay_state_machine;

    /**
     * UML creation
     */
    protected void init_behavior() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Is_off = new com.pauware.pauware_engine.Core.State("Is off");
        _Is_off.inputState();
        _Is_on = new com.pauware.pauware_engine.Core.State("Is on");
        _Relay_state_machine = new com.pauware.pauware_engine.Core.StateMachine(_Is_off.xor(_Is_on), "Relay", com.pauware.pauware_engine.Core.AbstractStateMachine.Don_t_show_on_system_out);
    }

    protected void start() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Relay_state_machine.fires("run", _Is_off, _Is_on);
        _Relay_state_machine.fires("stop", _Is_on, _Is_off);
        _Relay_state_machine.start();
    }

    /**
     * UML events
     */
    public void run() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Relay_state_machine.run_to_completion("run");
    }

    public void stop() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Relay_state_machine.run_to_completion("stop");
    }

    /**
     * UML actions
     */
    abstract public void activate();

    abstract public void disactivate();
}
