package com.franckbarbier._Programmable_thermostat_MODEL._Switchs;

public class Season_switch implements Season_switch_input {

    /**
     * UML control flow
     */
    private Season_switch_output _programmable_thermostat;
    /**
     * UML state machine diagram
     */
    private com.pauware.pauware_engine.Core.AbstractState _Is_cool;
    private com.pauware.pauware_engine.Core.AbstractState _Is_heat;
    private com.pauware.pauware_engine.Core.AbstractState _Is_off;
    private com.pauware.pauware_engine.Core.AbstractState _Is_on;
    private com.pauware.pauware_engine.Core.AbstractStateMachine _Season_switch_state_machine;

    /**
     * UML creation
     */
    private void init_structure(Season_switch_output programmable_thermostat) throws com.pauware.pauware_engine.Exceptions.State_exception {
        _programmable_thermostat = programmable_thermostat;
    }

    private void init_behavior() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Is_cool = new com.pauware.pauware_engine.Core.State("Is cool");
        _Is_heat = new com.pauware.pauware_engine.Core.State("Is heat");
        _Is_off = new com.pauware.pauware_engine.Core.State("Is off");
        _Is_off.inputState();
        _Is_on = (_Is_cool.xor(_Is_heat)).name("Is on");
        _Season_switch_state_machine = new com.pauware.pauware_engine.Core.StateMachine(_Is_on.xor(_Is_off), "Season switch", com.pauware.pauware_engine.Core.AbstractStateMachine.Don_t_show_on_system_out);
    }

    public void start() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Season_switch_state_machine.fires("cool", _Is_heat, _Is_cool);
        _Season_switch_state_machine.fires("cool", _Is_off, _Is_cool);
        _Season_switch_state_machine.fires("heat", _Is_cool, _Is_heat);
        _Season_switch_state_machine.fires("heat", _Is_off, _Is_heat);
        _Season_switch_state_machine.fires("off", _Is_on, _Is_off, true, _programmable_thermostat, "season_switch_turned_off");
        _Season_switch_state_machine.start();
    }

    public Season_switch(Season_switch_output programmable_thermostat) throws com.pauware.pauware_engine.Exceptions.State_exception {
        init_structure(programmable_thermostat);
        init_behavior();
    }

    /**
     * UML events
     */
    public void cool() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Season_switch_state_machine.run_to_completion("cool");
    }

    public void heat() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Season_switch_state_machine.run_to_completion("heat");
    }

    public void off() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Season_switch_state_machine.run_to_completion("off");
    }

    /**
     * UML <in>
     */
    public boolean in(String name) {
        return _Season_switch_state_machine.in_state(name);
    }
}
